(define guess
  (lambda (low high)
    (+ low (random (+ 1 (- high low))))))


(define low-end 1)
(define high-end 1000)
(define hidden (guess low-end high-end))

(define make-hidden
  (lambda ()
    (set! hidden (guess low-end high-end))))

(define how-many-trials
  (lambda (strategy strategy-low strategy-high low high)
    (let ((value (strategy low high)))
      (cond ((= (test value) 0)
	     1)
	    (else (+ 1
		     (how-many-trials strategy strategy-low strategy-high
				      (strategy-low low high value)
				      (strategy-high low high value))))))))

(define how-many-trials
  (lambda (strategy strategy-low strategy-high low high)
    (let ((value (strategy low high)))
      (cond ((= (test value) 0)
	     1)
	    (else (+ 1
		     (how-many-trials strategy strategy-low strategy-high
				      (strategy-low low high value)
				      (strategy-high low high value))))))))

(define test
  (lambda (v)
    (cond ((> v hidden) 1)
	  ((= v hidden) 0)
	  ((< v hidden) -1))))


(define square (lambda (x) (* x x)))

(define measure-mean-and-variance
  (lambda (no-of-trials strategy strategy-low strategy-high)
    (define helper
      (lambda (n sum sq-sum)
	(cond ((= n no-of-trials)
	       (let ((mean (/ sum n)))
		 (newline)
		 (display (round mean))
		 (newline)
		 (display (round (sqrt (/ (+ sq-sum
					     (* -2 mean sum)
					     (* n (square mean)))
					  (- n 1)))))))
	      (else
	       (make-hidden)
	       (let ((trial (how-many-trials strategy strategy-low
                                   strategy-high low-end high-end)))
		 (helper (+ n 1)
			 (+ sum trial)
			 (+ sq-sum (square trial))))))))
    (helper 0 0 0)))